#!/usr/bin/perl -w

use strict;
use warnings;

########
my $inFile         = "infile.txt";
my $outfile        = "outfile.txt";

my $seedSpeciesName = "Chimp";

########

my $oneLineLength = 60;
my $maxNameLength = 15;

open(IN,"$inFile") or die "Cannot find $inFile\n";
my @inFileCont = <IN>;
close IN;

my ($ref_names, $ref_seqs) = &fasHashReader2D(\@inFileCont);
$ref_seqs  = &matchFirstReturn($seedSpeciesName, $ref_names, $ref_seqs);
$ref_names = &white2names($maxNameLength, $ref_names);
&printing($outfile, $oneLineLength, $ref_names, $ref_seqs);

exit;
#####################

sub printing {
  my ($outfileSR, $oneLineLengthSR, $ref_namesSR, $ref_seqsSR) = @_;
  my @namesSR = @$ref_namesSR;
  my @secsSR = @$ref_seqsSR;


  open(OUT, ">$outfileSR");
  my $totalLengthSR = scalar(@{$secsSR[0]});
  print OUT @namesSR." $totalLengthSR\n";
  my $lineLastSite = 0;
  for (my $num=0; $num<$totalLengthSR;) {
    if(($lineLastSite + $oneLineLengthSR) > $totalLengthSR){
      $lineLastSite = $totalLengthSR;
    }else{
      $lineLastSite += $oneLineLengthSR;
    }
  
    for (my $sp=0; $sp<scalar(@secsSR); $sp++) {
      my $spaciesName = $namesSR[$sp];
      print OUT "$spaciesName";
      for (my $linePosition=$num; $linePosition < $lineLastSite; $linePosition++){
        print OUT "$secsSR[$sp][$linePosition]";
      }
      print OUT "\n";
  
    }
  
    $num = $num + $oneLineLengthSR;
    print OUT "\n";
  }
  close OUT;
}


sub seedRecPicker{
  my($seedSpeciesNameSR, $ref_namesSR) = @_;
  my @namesSR = @$ref_namesSR;
  my $hitNum = "";
  for(my $i = 0; $i<scalar(@namesSR); $i++){
    if($namesSR[$i] eq ">".$seedSpeciesNameSR){
      $hitNum = $i;
      last;
    }
  }
  return ($hitNum);
}


sub matchFirstReturn{
  my($seedSpeciesNameSR, $ref_namesSR, $ref_seqsSR)=@_;
  my @seqsSR = @$ref_seqsSR;
  my $referenceNum = &seedRecPicker($seedSpeciesNameSR, $ref_namesSR);

  for (my $i=0; $i<scalar(@seqsSR); $i++){
    next if $i == $referenceNum;
    for(my $j=0; $j<scalar(@{$seqsSR[0]}); $j++){
      $seqsSR[$i][$j] = $seqsSR[$referenceNum][$j] if $seqsSR[$i][$j] eq ".";
    }
  }
  return(\@seqsSR);
}


sub white2names{
  my($maxNameLengthSR, $ref_namesSR)=@_;
  for my $ele (@$ref_namesSR) {
    $ele =~ s/^[<|>]//;
    my $white = " " x ($maxNameLength - length($ele));
    $ele = $ele.$white;
  }
  return($ref_namesSR);
}


sub fasHashReader2D
{
  my ($inFileContSR) = @_;

  my $name = "";
  my $seq  = "";
  my $flag = 0;

  my @namesSR = ( );
  my @seqsSR  = ( );

  my $i = 0;
  foreach my $line (@$inFileContSR) {
    chomp($line);
    if($line =~ /^>/){  
      if($flag == 0){
        $name = $line;
        $flag = 1;  
      } else {
        $namesSR[$i] = $name;
        my @seqTemp = split(//,$seq);
        $seqsSR[$i]  = \@seqTemp;
        #print "seqsSR[$i] |@{$seqsSR[$i]}|\n";
        $i++;  

        $name = "$line";
        $seq = "";
      }
    } else {
      $seq .= $line; 
    }
  }
  $namesSR[$i] = $name;  
  my @seqTemp = split(//,$seq);
  $seqsSR[$i] = \@seqTemp;

  return (\@namesSR, \@seqsSR);
}
